unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics,
  Controls, Forms, Dialogs, ComCtrls, TeeGDIPlus,
  TeEngine, ExtCtrls, TeeProcs, Chart,
  TeeAnimations, TeeComma, TeeEdit;

type
  TForm2 = class(TForm)
    TabControl1: TTabControl;
    Chart1: TChart;
    Timer1: TTimer;
    ChartEditor1: TChartEditor;
    procedure TabControl1Change(Sender: TObject);
    procedure IniChart;
    procedure FormCreate(Sender: TObject);
    procedure Chart1DblClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form2: TForm2;

implementation

{$R *.dfm}
uses TeeThemes, Series, TeeDonut;

var animation: TSeriesAnimationTool;

procedure TForm2.Chart1DblClick(Sender: TObject);
begin
  ChartEditor1.Execute;
end;

procedure TForm2.FormCreate(Sender: TObject);
begin
  IniChart;
end;

procedure TForm2.IniChart;
var i: Integer;
begin
  ApplyChartTheme(TLookoutTheme, Chart1);

  Chart1.Walls.Visible:=False;
  Chart1.Legend.Visible := false;

  for i:=0 to 3 do
    with Chart1.AddSeries(THorizBarSeries) as THorizBarSeries do
    begin
      FillSampleValues(6);
      BarStyle:=bsRoundRectangle;
      Marks.Hide;
    end;

  with Chart1.AddSeries(TDonutSeries) as TDonutSeries do
  begin
    FillSampleValues(5);
    Circled:=True;
    Marks.Transparent:=True;
    AngleSize:=0;
    Active:=False;
  end;

  animation:=Chart1.Tools.Add(TSeriesAnimationTool) as TSeriesAnimationTool;
  animation.Play;
end;

procedure TForm2.TabControl1Change(Sender: TObject);
var i: Integer;
begin
  if TabControl1.TabIndex = 0 then
  begin
    Timer1.Enabled:=False;

    for i:=0 to Chart1.SeriesCount-1 do
      Chart1[i].Active:=(Chart1[i] is THorizBarSeries);

    animation.Play;
  end
  else if TabControl1.TabIndex = 1 then
  begin
    animation.Stop;

    for i:=0 to Chart1.SeriesCount-1 do
      if (Chart1[i] is TDonutSeries) then
        with (Chart1[i] as TDonutSeries) do
        begin
          Active:=True;
          AngleSize:=0;
        end
      else
        Chart1[i].Active:=False;

    Timer1.Enabled:=true;
  end;
end;

procedure TForm2.Timer1Timer(Sender: TObject);
var i: Integer;
begin
  for i:=0 to Chart1.SeriesCount-1 do
    if Chart1[i] is TDonutSeries then
      with Chart1[i] as TDonutSeries do
        if (AngleSize <= 360) then
           AngleSize:=AngleSize+5
        else
           Timer1.enabled:=False;
end;

end.
